unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Forms, ExtCtrls, StdCtrls, ExtDlgs, Spin, Classes, SysUtils, LazFileUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnClose: TButton;
    btnLoad: TButton;
    btnSave: TButton;
    ImageShow: TImage;
    ImageSource: TImage;
    lblHeight: TLabel;
    lblPercent: TLabel;
    lblWidth: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1: TPanel;
    SavePictureDialog1: TSavePictureDialog;
    sePercent: TSpinEdit;
    seWidth: TSpinEdit;
    seHeight: TSpinEdit;
    procedure btnCloseClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure seHeightEditingDone(Sender: TObject);
    procedure sePercentEditingDone(Sender: TObject);
    procedure seWidthEditingDone(Sender: TObject);
    procedure Scale;
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  rhsBitmapScale;

var
  PicturePath: String = '';
  NewWidth, NewHeight: Integer;

{ TForm1 }

procedure TForm1.btnLoadClick(Sender: TObject);
begin
  if PicturePath = '' then
    PicturePath := AppendPathDelim(Application.Location);

  OpenPictureDialog1.InitialDir := PicturePath;
  if OpenPictureDialog1.Execute then
  begin
    Screen.BeginWaitCursor;
    ImageSource.Picture.LoadFromFile(OpenPictureDialog1.FileName);
    PicturePath := OpenPictureDialog1.InitialDir;
    ImageShow.Picture.Assign(ImageSource.Picture);
    seWidth.Enabled := True;
    seHeight.Enabled := True;
    sePercent.Enabled := True;
    btnSave.Enabled := True;
    NewWidth := ImageShow.Picture.Width;
    NewHeight := ImageShow.Picture.Height;
    seWidth.Value := NewWidth;
    seHeight.Value := NewHeight;
    sePercent.Value := 100;
    Screen.EndWaitCursor;
  end;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
begin
  SavePictureDialog1.InitialDir := PicturePath;
  SavePictureDialog1.FileName := 'laz_scaled.png';

  if SavePictureDialog1.Execute then
  begin
    Screen.BeginWaitCursor;
    ImageShow.Picture.SaveToFile(SavePictureDialog1.FileName);
    Screen.EndWaitCursor;
  end;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.seWidthEditingDone(Sender: TObject);
begin
  NewWidth := seWidth.Value;
  NewHeight := 0;
  Scale;
end;

procedure TForm1.seHeightEditingDone(Sender: TObject);
begin
  NewWidth := 0;
  NewHeight := seHeight.Value;
  Scale;
end;

procedure TForm1.sePercentEditingDone(Sender: TObject);
begin
  NewWidth := Trunc((ImageSource.Picture.Width / 100) * sePercent.Value);
  NewHeight := 0;
  Scale;
end;

procedure TForm1.Scale;
begin
  ImageShow.Picture.Assign(ImageSource.Picture);
  BitmapScale(ImageShow.Picture.Bitmap, NewWidth, NewHeight);
  seWidth.Value := ImageShow.Picture.Width;
  seHeight.Value := ImageShow.Picture.Height;
  sePercent.Value := Trunc(100 / (ImageSource.Picture.Width / ImageShow.Picture.Width));
end;

end.
